/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

/* Lecture des fichiers de la base MNIST de caractères manuscrits.

   Cf http://yann.lecun.com/exdb/mnist/

   Il s'agit d'images 28x28, en niveaux de gris (dans 0..255).
*/

#ifndef MNIST
#define MNIST

typedef struct Image {
  int index;
  unsigned char *data; // taille 28x28 = 784, valeurs 0..255, par ligne
  int label; // 0..9
} image;

void mnist_print_pgm(char *file, image *img);

image *mnist_load(char *file, int lo, int hi);
/* renvoie les images [lo..hi[ contenues dans les deux fichiers
   file-images-idx3-ubyte et file-labels-idx1-ubyte. */

void mnist_delete_image(image *img);

#endif

